function a = relvm_r(hyper)

%=========================================================================
% The relevance vector machine for regression by M.Tipping
%==========================================================================
% Implementations as in SparseLib 1.0
% See : http://research.microsoft.com/mlp/RVM/relevance.htm
% Note : So far requires centered data!! 
% -gb-
%=========================================================================
% Reference : The Relevance Vector Machine
% Author    : Michael Tipping 
% Link      : http://citeseer.ist.psu.edu/tipping00relevance.html
%=========================================================================

 % hyperparams 
    
    % used kernel.
    a.child     = kernel;
    a.Xsv=[];
    % Maximum Number of Iterations
    a.maxIts    = 1000; 


    
    a.used=[];
    a.marginal=[];
    a.alpha=[];
    a.beta=[];
    a.gamma=[];
    


    
% Plot Information  
%    a.monitorIts =  0;



    a.bias =    0;
    
    a.beta0      = 1e2;
    
    a.prune_point= 50;		% percent

  p=algorithm('relvm_r');
  a= class(a,'relvm_r',p);

  a.algorithm.use_signed_output=0;
 
  if nargin==1,
    eval_hyper;
  end;
